//+------------------------------------------------------------------+
//|                                                   Trigg_sig1.mq4 |
//|                                                             RVA. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "RVA."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property  indicator_separate_window
#property  indicator_buffers 4            
#property indicator_color1 Gold      
#property indicator_color2 DarkOrange
#property indicator_color3 Turquoise
#property indicator_color4 DodgerBlue

//------
#property indicator_level1     0
#property indicator_level2     0.0004
#property indicator_level3     -0.0004
#property indicator_levelcolor clrDarkViolet
#property indicator_levelstyle STYLE_SOLID



//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//  ,     
#define SIGNAL_BAR 1


int width;

extern int Rperiod = 50;
extern int LSMA_Period = 50;
int Draw4HowLong;
int shift;
int i;
int j;
int loopbegin;
int length;
int lsma_length;

double lengthvar;
double tmp ;
double tmp2 ;
double wt[];
double sum[];
double lsma_sum[];
double lsma_ma[];
double middle[];
int c;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 7 additional buffers are used for counting.
   IndicatorBuffers(7);   
   
//---- drawing settings
//---  1  Gold  
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   //---  3 Turquoise
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,3);
//---  2 DodgerBlue
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   // 4 DarkOrange
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,3);
   
   
   
   SetIndexBuffer(4,sum);        
   SetIndexBuffer(5,wt);         
   SetIndexBuffer(6,lsma_ma);
   
//---- initialization done
   return(0);
  }

int start()

  {   Draw4HowLong = Bars-Rperiod - 5;                            //Rperiod = 20
      length = Rperiod;                                           //length now = 20  
      lsma_length = LSMA_Period;
      loopbegin = Draw4HowLong - length - 1;   
      

      for(shift = loopbegin; shift >= 0; shift--)  //  MAIN For Loop
      { 
         sum[1] = 0;                                              
         for(i = length; i >= 1  ; i--)             //LSMA loop
         {
         lengthvar = length + 1;                               //lengthvar = 21  
         lengthvar /= 3;                                       //lengthvar = 7
         tmp = 0;
         tmp = ( i - lengthvar)*Close[length-i+shift];         //tmp = 20 - 7 * close[20-i+shift]
         sum[1]+=tmp;
         }
         wt[shift] = sum[1]*6/(length*(length+1));  
         j = shift;
         lsma_ma[shift] = wt[j+10] + (wt[j]-wt[j+40])* 2/(lsma_length+1);
  
                          
//========== COLOR CODING ===========================================                       
      
//----  1 Gold - 
            ExtMapBuffer1[shift] = (wt[shift]-lsma_ma[shift]);
//---  2 DarkOrange             
            ExtMapBuffer2[shift] = (wt[shift]-lsma_ma[shift]);
//---  3 Turquoise          
            ExtMapBuffer3[shift] = (wt[shift]-lsma_ma[shift]); 
//----  4 DodgerBlue            
            ExtMapBuffer4[shift] = (wt[shift]-lsma_ma[shift]); 
            
            
            
            if (wt[shift]  < lsma_ma[shift])
            {
                ExtMapBuffer4[shift] = EMPTY_VALUE;
                ExtMapBuffer3[shift] = EMPTY_VALUE;
           }          
        
        }
  //---- done
//----  ,   
//----       
	  static int PrevSignal = 0, PrevTime = 0;
//----       0-,     
//----  .     , .
	  if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) 
	      return(0);
//---- ,    
	  PrevTime = Time[0];

//----          (PrevSignal=0)
	  if(PrevSignal <= 0)
	    {
	    
		     //---- ,       :
		     if(ExtMapBuffer1[SIGNAL_BAR]-(-0.0004) > 0 && 
				      -0.0004 - ExtMapBuffer1[SIGNAL_BAR+1] >= 0)
		       {
			        //----  ,     - 
			        PrevSignal = 1;
			        //----   :
			       PlaySound("oblaka"); 
		
		       }
	    }
	    
//    
	  if(PrevSignal >= 0)
	    {
		     if(0.0004 - ExtMapBuffer1[SIGNAL_BAR] > 0 && 
				      ExtMapBuffer1[SIGNAL_BAR+1] - 0.0004 >= 0)
		       {
			        PrevSignal = -1;
			        PlaySound("shar"); 
		}
}
  //----	
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

  


